FileUtils::mkdir_p creates additional (unrequested) directory on Cygwin

02/14/2017 12:04 PM - rovf (Ronald Fischer)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.2.5p319 (2016-04-26 revision

54774) [x86_64-cygwin]

Backport: 2.2: DONE, 2.3: DONE, 2.4: DONE

Description

FileUtils.mkdir(SOMEPATH) on Cygwin will create a directory ./c: in addition to SOMEPATH, if the following two conditions are met:

-SOMEPATH must be specified as absolute path using Windows drive letters and forward slashes as separators (so called

"mixed-mode pathes" in Cygwin technologiy; see man cygpath).

The parent directory of SOMEPATH does not exist.

The enclosed zip file demonstrates the problem. To run it, extract it to some directory, cd to this directory and then source the shell

script file by typing

. mkdir_test.shell

This script will create a directory c:/tmp, set up everything so that the error can become evident, and the runs mkdir_test.rb. This in

turn creates a directory c:/tmp/foo/bar, and shows (using File.exist?), that in addition a director ./c: has been created. If you study the

Ruby code, it will be obvious what's going wrong.

My guess is that at one point, FileUtils::mkdir needs to decide whether the path to be created is relative or absolute, and since c:/ is

an absolute path only in the realm of Cygwin, but not in Unix, it creates a local directory ./c:. Note however that it does NOT create a

full path ./c:/tmp/foo/bar. The requested directory is created as (in Windows notation) C:\TMP\FOO\BAR, as requested, and from this,

I conclude, that mkdir_p is, by and large, Cygwin-aware. The error is not that the requested directory was not created, but that this

mkdir_p call has created two directories, not one. Indeed, if I pass the path as

FileUtils.mkdir_p('/cygdrive/c/tmp/foo/bar')

 everything goes fine.

I can reproduce the error using the 64 Bit version of Cygwin. I don't know whether it also occurs in 32 Bit Cygwin.

Associated revisions

Revision 3261cfd88172a0ab86dcdffd4a8b0b5604970146 - 02/16/2017 08:42 AM - nobu (Nobuyoshi Nakada)

fileutils.rb: do not make root

lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

directory which should be exist and cannot be made with mkdir

recent Cygwin can make a directory contains a colon.

[Bug #13214]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57640 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3261cfd8 - 02/16/2017 08:42 AM - nobu (Nobuyoshi Nakada)

fileutils.rb: do not make root

lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

directory which should be exist and cannot be made with mkdir

recent Cygwin can make a directory contains a colon.

[Bug #13214]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57640 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision acc6a302e4587b58c40f4bf5c5ef6b21ba79c0e2 - 03/25/2017 06:24 PM - U.Nakamura 
merge revision(s) 57640: [Backport #13214]

    fileutils.rb: do not make root

    * lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

      directory which should be exist and cannot be made with mkdir

      recent Cygwin can make a directory contains a colon.

      [Bug #13214]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@58120 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision acc6a302 - 03/25/2017 06:24 PM - U.Nakamura 

merge revision(s) 57640: [Backport #13214]

    fileutils.rb: do not make root

    * lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

      directory which should be exist and cannot be made with mkdir

      recent Cygwin can make a directory contains a colon.

      [Bug #13214]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@58120 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0dc5e45028fdeeac5ae507d95f3616e9e74e7fa7 - 03/27/2017 04:57 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57640: [Backport #13214]

    fileutils.rb: do not make root

    * lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

      directory which should be exist and cannot be made with mkdir

      recent Cygwin can make a directory contains a colon.

      [Bug #13214]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58180 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0dc5e450 - 03/27/2017 04:57 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57640: [Backport #13214]

    fileutils.rb: do not make root

    * lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

      directory which should be exist and cannot be made with mkdir

      recent Cygwin can make a directory contains a colon.

      [Bug #13214]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58180 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0deee2020f7e455a901ffca4d28655eb386df390 - 05/09/2017 02:56 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57640: [Backport #13214]

    fileutils.rb: do not make root

    * lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

      directory which should be exist and cannot be made with mkdir

      recent Cygwin can make a directory contains a colon.

      [Bug #13214]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@58631 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0deee202 - 05/09/2017 02:56 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57640: [Backport #13214]

    fileutils.rb: do not make root

    * lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

      directory which should be exist and cannot be made with mkdir

      recent Cygwin can make a directory contains a colon.

      [Bug #13214]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@58631 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
History

#1 - 02/16/2017 08:42 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r57640.

fileutils.rb: do not make root

lib/fileutils.rb (FileUtils#mkdir_p): no need to make root

directory which should be exist and cannot be made with mkdir

recent Cygwin can make a directory contains a colon.

[Bug #13214]

#2 - 03/23/2017 02:43 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: UNKNOWN to 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED

#3 - 03/25/2017 06:24 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED to 2.2: DONE, 2.3: REQUIRED, 2.4: REQUIRED

ruby_2_2 r58120 merged revision(s) 57640.

#4 - 03/27/2017 04:57 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: DONE, 2.3: REQUIRED, 2.4: REQUIRED to 2.2: DONE, 2.3: DONE, 2.4: REQUIRED

ruby_2_3 r58180 merged revision(s) 57640.

#5 - 05/09/2017 02:56 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: DONE, 2.3: DONE, 2.4: REQUIRED to 2.2: DONE, 2.3: DONE, 2.4: DONE

ruby_2_4 r58631 merged revision(s) 57640.

Files

mkdir_error_demo.zip 738 Bytes 02/14/2017 rovf (Ronald Fischer)
